import { MarginDurationsProps } from './value-objects/margin-durations.value-object';
import { ScheduleProps } from './value-objects/schedule.value-object';
import { WaypointProps } from './value-objects/waypoint.value-object';

// All properties that an Ad has
export interface AdProps {
  userId: string;
  driver: boolean;
  passenger: boolean;
  frequency: Frequency;
  fromDate: string;
  toDate: string;
  schedule: ScheduleProps;
  marginDurations: MarginDurationsProps;
  seatsProposed: number;
  seatsRequested: number;
  strict: boolean;
  waypoints: WaypointProps[];
}

// Properties that are needed for an Ad creation
export interface CreateAdProps {
  userId: string;
  driver: boolean;
  passenger: boolean;
  frequency: Frequency;
  fromDate: string;
  toDate: string;
  schedule: ScheduleProps;
  marginDurations: MarginDurationsProps;
  seatsProposed: number;
  seatsRequested: number;
  strict: boolean;
  waypoints: WaypointProps[];
}

export interface DefaultAdProps {
  driver: boolean;
  passenger: boolean;
  marginDurations: MarginDurationsProps;
  strict: boolean;
  seatsProposed: number;
  seatsRequested: number;
}

export enum Frequency {
  PUNCTUAL = 'PUNCTUAL',
  RECURRENT = 'RECURRENT',
}
