import {
  ValidateBy,
  ValidationArguments,
  ValidationOptions,
  buildMessage,
} from 'class-validator';

export const IsSchedule = (
  validationOptions?: ValidationOptions,
): PropertyDecorator =>
  ValidateBy(
    {
      name: '',
      constraints: [],
      validator: {
        // eslint-disable-next-line @typescript-eslint/no-unused-vars
        validate: (value, args: ValidationArguments): boolean =>
          Object.keys(value).length > 0,
        defaultMessage: buildMessage(
          () => `schedule is invalid`,
          validationOptions,
        ),
      },
    },
    validationOptions,
  );
